/*********************************
**Wire: 
*Pin 0 - player TX; 
*Pin 1 - DfPlayer Busy
*Pin 2 - PIR Sensor HIGH Aktiv || BS 170 invertiert + intern LED
*        !Das Signal beleibt ca. 20sec. an!
*Pin 3 - player RX;  not used 
** Board : Digispark
** DFPlayer_Mini_MP3.h  Modified for DigiSpark by Lp
**********************************/

#define songtime 30  //   Spieldauer z.B. 30sec, wenn nicht bis Ende Lied.

#include <SoftSerial.h>   // von DigiSpark! Statt SoftwareSerial.h
#include <DFPlayer_Mini_Mp3_with_DigiSpark.h>  
                          /*In "DFPlayer_Mini_Mp3.h und *.cpp" ersetzt:
                            "SoftwareSerial" durch "SoftSerial" */
SoftSerial mySerial(3, 0); // RX, TX   (Rx brauche ich z.Z. nicht)

boolean Playmode;
boolean DFPlayer_Busy = false;
boolean sensorOut_state;

void setup () {
  pinMode(1,INPUT_PULLUP);    //BUSY vom DFPlayer
  pinMode(2,INPUT_PULLUP);    //PIR-Sensor Signal
  pinMode(3,INPUT_PULLUP);    //Playmode Auswahl
 
  Serial.begin (9600);
  mySerial.begin (9600);
  mp3_set_serial (mySerial);  //set softwareSerial for DFPlayer-mini mp3 module 
  delay(1);                   // delay 1ms to set volume
  mp3_set_volume (15);        // value 0~30
  delay(20);                  // delay 1ms to set volume
  delay(25000);   //Warten nach PowerOn bis Sensor definitiv aus
}
void loop () {   
  Playmode = digitalRead(3);  //time oder End Soung -Schalter
  if(Playmode == 0) {         // Lied bis Ende spielen
      sensorOut_state = digitalRead(2); // connect Pin2 to BUSY pin of player
      if(sensorOut_state == LOW) {
        mp3_next ();     // Start bzw. nächster Titel
        do {
          DFPlayer_Busy = digitalRead(1); // connect Pin1 to BUSY pin of player(df_Busy == LOW) { 
          delay(100);
        } while (DFPlayer_Busy == HIGH && (Playmode = digitalRead(3)) == 0); //Abbruch wenn Schalter
      }
      else {
       mp3_pause ();
       delay(200);
      }
}
else {                  // Zeitbedingng
   sensorOut_state = digitalRead(2); // connect Pin2 to BUSY pin of player
   if(sensorOut_state == LOW) {
    mp3_next ();     // Start bzw. nächster Titel
    delay(songtime*1000);   // Spiele 
    mp3_pause ();
    delay(200);
   }
   else {
    delay(200);
   }
}      
}

