/*********************************
**Wire: 
*Pin 0 - player TX; 
*Pin 1 - DfPlayer Busy  (interne LED)
*Pin 2 - PIR Sensor HIGH Aktiv; !Das Signal beleibt ca. 20sec. an!
*Pin 3 - player RX;  not used 
** Board : Digispark
**********************************/

#include <SoftSerial.h>    //Speziell für Digispark
SoftSerial mySerial(3, 0); // RX, TX  (Rx brauche ich nicht)

#define Start_Byte 0x7E
#define Version_Byte 0xFF
#define Command_Length 0x06
#define End_Byte 0xEF
#define Acknoledge 0x00  // Returns info with command 0x41 [0x01: info, 0x00: no info]

#define songtime 30  //   Spieldauer z.B. 30sec, wenn nicht bis Ende Lied.

boolean Playmode;
boolean DFPlayer_Busy = false;
boolean sensorOut_state;

void setup () {
  pinMode(1,INPUT_PULLUP);    //BUSY vom DFPlayer
  pinMode(2,INPUT_PULLUP);    //PIR-Sensor Signal
  pinMode(3,INPUT_PULLUP);    //Playmode Auswahl
 
  mySerial.begin (9600);

  set_volume(20);              //  Start Laustärke value 0~30
  delay(20);                   // delay 1ms to set volume
  //delay(25000);   //Warten nach PowerOn bis Sensor definitiv aus ist
}

void loop () {   
  Playmode = digitalRead(3);  //time oder End Soung -Schalter
  if(Playmode == 0) {         // Lied bis Ende spielen
      sensorOut_state = digitalRead(2); // connect Pin2 to BUSY pin of player
      if(sensorOut_state == LOW) {
        play_next ();     // Start bzw. nächster Titel
        do {
          DFPlayer_Busy = digitalRead(1); // connect Pin1 to BUSY pin of player(df_Busy == LOW) { 
          delay(100);
        } while (DFPlayer_Busy == HIGH && (Playmode = digitalRead(3)) == 0); //Abbruch wenn Schalter
      }
      else {
       pause ();
       delay(200);
      }
}
else {                  // Zeitbedingung
   sensorOut_state = digitalRead(2); // connect Pin2 to BUSY pin of player
   if(sensorOut_state == LOW) {
    play_next ();           // Start bzw. nächster Titel
    delay(songtime*1000);   // Spielzeit 
    pause ();
    delay(200);
   }
   else {
    delay(200);
   }
}      
}

void pause() {
    execute_CMD(0x0E,0,0);
    delay(200);
}

//void play() {               
//    execute_CMD(0x0D,0,1);
//    delay(200);
//}

void play_next() {
   execute_CMD(0x01,0,1);
   delay(200);
}

void set_volume(uint16_t wert) {
   execute_CMD(0x06,1,wert);
   delay(200);
}

void execute_CMD(byte CMD, byte Par1, byte Par2)
// Excecute the command an parameters
{
//Calculate the checksum (2 bytes)
word checksum = -(Version_Byte + Command_Length + CMD + Acknoledge + Par1 +Par2);
//Build the command_line
byte Command_line[10] = {Start_Byte, Version_Byte, Command_Length, CMD, Acknoledge,
Par1, Par2, highByte(checksum), lowByte(checksum), End_Byte};  
//Send the command line to the module
for (byte k=0; k<10; k++)
{
mySerial.write( Command_line[k]);
}
}
